#include <avr/io.h>

#include "adc.h"
#include "macros.h"

void adc_init(unsigned char port)
{
    ADMUX = port & 0b111111; // set ADC input port
    
    // ADC enabled, prescaler of 8
    ADCSRA = (1 << ADEN) | (1 << ADPS1) | (1 << ADPS0);
    
    // Because we just changed channels, we need to run one conversion
    // and wait for the signal to stabilize.
    ADCSRA |= (1 << ADSC); // Start conversion
    while (bit_test(ADCSRA, ADSC))
        ; // Wait for the conversion to complete
}

int adc_read(void)
{
    ADCSRA |= (1 << ADSC); // Start conversion
    while (bit_test(ADCSRA, ADSC))
        ; // Wait for the conversion to complete
    
    unsigned int bottom = ADCL;
    unsigned int top = ADCH;
    unsigned int result = (top << 8) + bottom;
    
    return result;
}