// Originally by
// Neil Gershenfeld
// 12/8/10
//
// Adapted by Matt Keeter
//
// (c) Massachusetts Institute of Technology 2010
// Permission granted for experimental and personal use;
// license for commercial sale available from MIT.
//

#ifndef MACROS_H
#define MACROS_H

#define output(directions,pin) (directions |= pin) // set port direction for output
#define input(directions,pin) (directions &= (~pin)) // set port direction for input 

#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin
#define pin_test(pins,pin) (pins & pin) // test for port pin

#define set_reg(reg, bit)  (reg |= (1 << bit)) // set register bit
#define clear_reg(reg, bit)  (reg &= ~(1 << bit)) // set register bit
#define bit_test(byte,bit) (byte & (1 << bit)) // test for bit set

#endif